(define (guarded-system-loader package-name place)
  (let ((directory
	 (let ((directory (directory-pathname (current-load-pathname))))
	   (pathname-new-directory directory
				   (append (pathname-directory directory)
					   (list 'UP place))))))
    (lambda ()
      (if (not (name->package package-name))
	  (with-working-directory-pathname directory
	    (lambda ()
	      (load "make")))))))

(define-load-option 'SF
  (guarded-system-loader '(scode-optimizer) "sf"))

(define-load-option 'CREF
  (guarded-system-loader '(cross-reference) "cref"))

(define-load-option 'EDWIN
  (guarded-system-loader '(edwin) "edwin"))

(define-load-option 'COMPILER
  (lambda () (load-option 'SF))
  (guarded-system-loader '(compiler) "compiler"))

(further-load-options standard-load-options)